---
title: XRViewerPose
slug: Web/API/XRViewerPose
tags:
  - 3D
  - API
  - AR
  - Graphics
  - Mixed Reality
  - Overview
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - augmented
---
<p>{{APIRef("WebXR Device API")}}{{secureContext_header}}</p>

<p><span class="seoSummary">The WebXR Device API interface <code><strong>XRViewerPose</strong></code> represents the pose (the position and orientation) of a viewer's point of view on the scene. Each <code>XRViewerPose</code> can have multiple views to represent, for example, the slight separation between the left and right eye.</span> This view can represent anything from the point-of-view of a user's XR headset to the viewpoint represented by a player's movement of an avatar using mouse and keyboard, presented on the screen, to a virtual camera capturing the scene for a spectator.</p>

<h2 id="Properties">Properties</h2>

<p><em>In addition to the properties inherited from {{domxref("XRPose")}}, <code>XRViewerPose</code> includes the following:</em></p>

<dl>
 <dt>{{domxref("XRViewerPose.views", "views")}} {{ReadOnlyInline}}</dt>
 <dd>An array of {{domxref("XRView")}} objects, one for each viewpoint on the scene which is needed to represent the scene to the user. A typical headset provides a viewer pose with two views whose {{domxref("XRView.eye", "eye")}} property is either <code>left</code> or <code>right</code>, indicating which eye that view represents. Taken together, these views can reproduce the 3D effect when displayed on the XR device.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The <code>XRViewerPose</code> object is used to describe the state of a viewer of a WebXR scene as it's tracked by the user's XR hardware. The viewer may be the virtual representation of the user, or it may represent another device or interface which may serve as the source of a position and orientation that make up a view upon the scene. For example, every player in a MMORPG might have an instance of <code>XRViewerPose</code> to provide a way to calculate what they can see; if the game provides a mechanism that tells the player if another player sees them, or that they see another player, this information becomes crucial.</p>

<p>An <code>XRViewerPose</code> is always obtained and referenced relative to an existing {{domxref("XRReferenceSpace")}}. This ensures that positions and orientations are reported using the expected relative coordinate system.</p>

<p>To render a scene using the <code>XRViewerPose</code> representing the user's head, one would iterate over the views in the {{domxref("XRViewerPose.views", "views")}} array, rendering them one after another. By calling {{domxref("WebGLRenderingContext.viewport", "viewport()")}} on the WebGL context, specifying the <code>XRView</code> as input, you can get the viewport to use when rendering in order to draw the frame for that eye into the correct part of the drawing surface.</p>

<p>Also, when rendering the scene for spectators or other players in a multiplayer game, the {{domxref("XRPose.transform", "transform")}} of the <code>XRViewerPose</code> can be used to determine both placement and facing direction of the other players in the game, so that they can be drawn in the correct place with the correct facing.</p>

<p>The viewer's pose for the animation frame represented by {{domxref("XRFrame")}} can be obtained by calling the frame's {{domxref("XRFrame.getViewerPose", "getViewerPose()")}} method, specifying the reference space in which the origin's position should be computed. The returned <code>XRViewerPose</code> tells you where the viewer is and what direction they're facing at the time at which the frame takes place.</p>

<h2 id="Examples">Examples</h2>

<p>{{page("/en-US/docs/Web/API/XRViewerPose/views", "Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#xrviewerpose-interface','XRViewerPose')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRViewerPose")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a></li>
 <li>{{domxref("XRPose")}} and {{domxref("XRView")}}</li>
</ul>
